﻿var httpReq = null;
plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);
cnArea.maxContentItems = 41;

var interval = 500;
//var online_state = framework.system.network.online; // true if online
var offline_interval = "";  //used to create timer
var online_state = "";  // 1 is online
var plugin_state = 0;//0 -  showing book types ; 1-showing books - not used now
var plugin_state_item = "";	// not used now
var page = "";  //holds pages
var tmptable = ""; // holds data for each fetch
var itemsarray = "";  //holds data for all fetches on an item
var bigarray = new Array(); //holds all data
var BookTypeItems = "";  // holds BookTypeItems
//Main View.. All the news types.. 
var bookTypes = [_lit_fiction,_mystery_thriller,_romance,_science_fiction,_bio_memoirs,_history,_politics,_science];
// Links.. for all the news types
var categoryCodes = ["17","18","23","25","2","9","11079","75"];



function On_Open() {
	Make_BookTypeItems();
	lblLoad.visible = false;
	Show_BookTypes();	
}


// function to make the main view items 
function Make_BookTypeItems() {
   //tmptable = new Array();
   BookTypeItems = new Array();
   for(var bookIndx=0;bookIndx<=bookTypes.length-1;bookIndx++){
      var bookItem = new ContentItem();
      bookItem.onDrawItem = DrawBackground;
      bookItem.heading =  bookTypes[bookIndx];
      bookItem.onDetailsView = BookTypeLink_Clicked;
      var url = new String("http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=1DSKFB0DE5Y0F3RYGZG2&AssociateTag=mikssupgad20"
+ "&Version=2007-02-22&Operation=ItemSearch&SearchIndex=Books&BrowseNode=" + "[cat]" + "&Sort=salesrank&ResponseGroup=Medium&ItemPage=" + "[page]");
      url = url.replace("[cat]", categoryCodes[bookIndx]);
      bookItem.source = url;
      BookTypeItems.push(bookItem);
   }
}

// function to display the main view.. 
function  Show_BookTypes()
{
   cnArea.removeAllContentItems();

   for(var bookIndx=bookTypes.length-1;bookIndx>=0;bookIndx--){
      cnArea.addContentItem(BookTypeItems[bookIndx], gddItemDisplayInSidebar );
   }
}

function DrawBackground(item, target, graphics, x, y, width, height) {
  var bgColor = getBookBgColor(item.heading);
  graphics.DrawRect(x, y, x+5, height, bgColor, bgColor);
  graphics.DrawText(x+6, y, width, height, "  " + item.heading, gddColorNormalText, 
  gddTextFlagSingleLine + gddTextFlagVCenter, gddFontNormal);
}

//Colored bars.. in the main view before each category.
function getBookBgColor(heading) {

  var bgColor = "#ffffdd";
  if(heading==_lit_fiction)
    bgColor = '#aa0033'
  else if(heading==_mystery_thriller)
    bgColor= "#ffcc00";
  else if(heading==_romance)
    bgColor = "#FF1243";
  else if(heading==_science_fiction)
   bgColor = "#0e9ffe";
  else if(heading==_bio_memoirs)
    bgColor = "#008000";
  else if(heading==_history)
   bgColor = "#FF20DE";
  else if(heading==_politics)
    bgColor = "#2412FE";
  else if(heading==_science)
   bgColor = "#FF7403";

  return bgColor;
}

function addTmpTable(item) {	//redo - just parse that booktype item when clicked
		var urlini = "";
		var url = "";
		urlini = item.source;
		url = "";
		itemsarray = new Array();
		tmptable = new Array();
		for(var i = 1; i<=4;i++){
			url = urlini.replace("[page]", i);
			page = i;
			FetchAndParse(url);
			itemsarray = itemsarray.concat(tmptable);
		}
		bigarray[item.heading] = itemsarray;
}

// Event listener for Each category link
function BookTypeLink_Clicked(item) {	//redo to get different array
	cnArea.removeAllContentItems();
	lblLoad.visible = true;
	// check if data exists for this book type
	var pass = 0;
	for (key in bigarray)  {
		if(item.heading == key && bigarray[item.heading].length == 40){
			pass = 1;
			break;
		}
	}
	if(pass ==0 && framework.system.network.online) {
		addTmpTable(item); 
		if(bigarray[item.heading].length == 40) {
			finalWrite(item.heading);
		//Back link
			var backToMain = new ContentItem(); 
			backToMain.heading = _back2main + "  - " + _showing + ": " +  item.heading;
			backToMain.onDetailsView = Show_BookTypes;
			cnArea.AddContentItem(backToMain, gddItemDisplayInSidebar);
		}
		else{
			Show_BookTypes();
			var noConn = new ContentItem(); 
			noConn.heading = _connection;
			noConn.onDetailsView = Show_BookTypes;
			//cnArea.removeAllContentItems();
			cnArea.AddContentItem(noConn, gddItemDisplayInSidebar);
		}
	}
	else {
		if(pass==1) {
			finalWrite(item.heading);
			//Back link
			var backToMain = new ContentItem(); 
			backToMain.heading = _back2main + "  - " + _showing + ": " +  item.heading;
			backToMain.onDetailsView = Show_BookTypes;
			cnArea.AddContentItem(backToMain, gddItemDisplayInSidebar);
		}
		else {
			Show_BookTypes();
			var noConn = new ContentItem(); 
			noConn.heading = _offline;
			noConn.onDetailsView = Show_BookTypes;
			//cnArea.removeAllContentItems();
			cnArea.AddContentItem(noConn, gddItemDisplayInSidebar);	
		}
	}
	lblLoad.visible = false;
}


//Fetches the Rss feed from the selected site.
function FetchAndParse(url) {
  httpReq = new XMLHttpRequest();
  httpReq.onreadystatechange = OnRssFeed;
  httpReq.open("GET", url, false);
// Send the Method Data
	try {
		httpReq.send(""); 
	} catch (e) {
		httpReq = false;
	}
}

function OnRssFeed() {
   if(httpReq.readyState==4){
      if(httpReq.status==200){
         var doc = new DOMDocument();
         doc.loadXML(httpReq.responseText);
	 getDetail(doc);
      }
   }
}

//Details view handler. Formats the html code and displays
function OnDetailsView(item) {
  
  var htmlcontent = "<html><head></head><body>";
  htmlcontent += item.snippet;
  htmlcontent += "</body></html>";
  var control = new DetailsView();
  control.SetContent(item.source, item.time_created, htmlcontent, true, item.layout);
  control.html_content = true;
  var details = new Object();
  details.details_control = control;
  
  return details;
}

function getDetail(response) {	//redo array

		tmptable = new Array();
	
           	if (response == null || typeof(response) != "object" || 
                      response.firstChild == null) {
			html = _data_not_available;
			var curItem = null;
			curItem = new ContentItem();  // item does not already exist
			curItem.heading = html;
			curItem.onDetailsView = NewOnline;
			cnArea.addContentItem(curItem, gddItemDisplayInSidebar|gddItemDisplayAsNotificationIfSidebarHidden);
              	return;
           	}
		// Get reliable pagenumber
           	var pagenum = response.getElementsByTagName("ItemPage")[0].firstChild.nodeValue;

		// Get a list of the <"Item"> element nodes in the file
           	var itemlist = response.getElementsByTagName("Item");
           // Loop through all <"Item"> nodes
		
           for (var i = 0; i <= (itemlist.length -1) ; i++) { 
		var html = "";
             // For each node, get child nodes.
			if(itemlist[i].getElementsByTagName("EditorialReviews").length>=1){
				var source = itemlist[i].getElementsByTagName("Source")[0].firstChild.nodeValue;
				var content = itemlist[i].getElementsByTagName("Content")[0].firstChild.nodeValue;
			}
			else { var source = "blank"; 
				var content = "blank"; }
			
			if(itemlist[i].getElementsByTagName("PublicationDate").length>=1){
				var pubDate = itemlist[i].getElementsByTagName("PublicationDate")[0].firstChild.nodeValue;	
			}
			else { var pubDate = "blank"; }

			if(itemlist[i].getElementsByTagName("Author").length>=1){
				var author = itemlist[i].getElementsByTagName("Author")[0].firstChild.nodeValue;	
			}
			else { var author = ""; }

			if(itemlist[i].getElementsByTagName("DetailPageURL").length>=1){
				var link = itemlist[i].getElementsByTagName("DetailPageURL")[0].firstChild.nodeValue;
			}
			else { var link = "blank"; }

			if(itemlist[i].getElementsByTagName("ListPrice").length>=1){
				var tmplistprice = itemlist[i].getElementsByTagName("ListPrice")[0];
				var listprice = " " + _listprice + ": " + tmplistprice.getElementsByTagName("FormattedPrice")[0].firstChild.nodeValue ;
			}
			else{var listprice = "  " + _visit_link_for_price; }

			if(itemlist[i].getElementsByTagName("LowestNewPrice").length>=1){
				var tmplownewprice = itemlist[i].getElementsByTagName("LowestNewPrice")[0];
				var lownewprice= "; " + _lowest_price + ": " + tmplownewprice.getElementsByTagName("FormattedPrice")[0].firstChild.nodeValue + " new";
			}
			else { var lownewprice = ""; }

			if(itemlist[i].getElementsByTagName("Title").length>=1){
				var title = itemlist[i].getElementsByTagName("Title")[0].firstChild.nodeValue;
			}
			else { var title = "blank"; }

				if(itemlist[i].getElementsByTagName("SmallImage").length>=1){
					var tmpurl = itemlist[i].getElementsByTagName("SmallImage")[0];
					var picurl= tmpurl.getElementsByTagName("URL")[0].firstChild.nodeValue;
					var picsrc = "<IMG SRC=\"" + picurl + "\" ALT=\"pic\" >";
				}
				else { var picsrc = ""; }

			//var href = "<a href=\"" + link + "\"  target=\"_blank\" onclick=\"_IG_Analytics('UA-1373225-2', '/kidsbooksgadget/linkclick')\">" 
			//+ title + "</a>";
			var href = "<a href=\"" + link + "\" >" 
			+ title + "</a>";
			if(i==0) {
				href += "<img src=\"http://www.assoc-amazon.com/e/ir?t=mikssupgad-20&amp;l=ur2&amp;o=1\" width=\"1\" height=\"1\" border=\"0\" alt=\"\" style=\"border:none !important; margin:0px !important;\" />";
			}
			html += "<table><tr>";
			html += "<td align=\"center\">" + picsrc + "</td>";
			var align = "align=\"left\" valign=\"middle\"";
			html += "<td " +  align + ">" +  href + "<EM>" +  listprice + " " + lownewprice + "</EM></td></tr></table>";
			html += "<p><u>Review</u>: " + source + "<br/><br/>" + content + "</p>";

	
	content = content.replace(/<([^>]|\n)*>/g,'');  // remove html tags if present
        content = content.replace(/&nbsp;/g, ' ');
        content = content.replace(/&quot;/g, '"');
        content = content.replace(/&amp;/g, '&');
        content = content.replace(/&#39;/g, '\'');
        link = link.replace(/&amp;/g, '&');
        link = link.replace(/&#39;/g, '\'');
        title = title.replace(/&amp;/g, '&');
        title = title.replace(/&#39;/g, '\'');

	var item = new Object();
	item.link=link;
	item.author=author;
	item.listprice=listprice;
	item.lownewprice=lownewprice;
	item.title= ((i+1)+((page*10)-10)) + ") " + title;
	item.picurl=picurl;
	item.html= html;
	var date = pubDate;
	var date_array=pubDate.split("-");
	pubDate = date_array[0]+ " , " + date_array[1] + " , " + date_array[2];
	item.pubDate=pubDate;
	tmptable.push(item);	
	}	
}


function finalWrite(heading) {
	var itarray = new Array();
	itarray = bigarray[heading];
	cnArea.removeAllContentItems();
	for (var i = 39; i >= 0 ; i--) { 
		var item = itarray[i];
		var curItem = null;
		curItem = new ContentItem();  // item does not already exist
		curItem.source = item.author;
		curItem.layout =  gddContentItemLayoutNowrapItems;
		curItem.flags = gddContentItemFlagShareable | gddContentItemFlagNoRemove | gddContentItemFlagInteracted;
		curItem.onDetailsView = OnDetailsView;
		curItem.heading = item.title;
		curItem.snippet =  item.html ; // to show in details view (for Audio)
		var tm = new Date(item.pubDate);
		var date_string = Date.UTC();
		tm.setTime(date_string);
		tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
		curItem.open_command = item.link;//to open the browser
		cnArea.addContentItem(curItem, gddItemDisplayInSidebar|gddItemDisplayAsNotificationIfSidebarHidden);
	}
}

function lblLoad_onclick() {

}
